<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolPodlaDruhuAHodnotenia;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use InvalidArgumentException;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\DataTableRowContract;

/**
 * Class PocetKontrolPodlaDruhuAHodnoteniaDataTableRow
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolpodlaDruhuAHodnotenia
 */
final class PocetKontrolPodlaDruhuAHodnoteniaDataTableRow implements DataTableRowContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var array
     */
    private array $hodnoteniePocet = [];

    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum
     */
    private DruhEmisnejKontrolyEnum $druhEmisnejKontrolyEnum;

    /**
     * @var int
     */
    private int $spolu = 0;

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum $druhEmisnejKontroly
     */
    public function __construct(DruhEmisnejKontrolyEnum $druhEmisnejKontroly)
    {
        $this->druhEmisnejKontrolyEnum = $druhEmisnejKontroly;

        foreach (HodnotenieEmisnejKontrolyEnum::cases() as $case) {
            $this->hodnoteniePocet[$case->value] = 0;
        }
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia): self
    {
        if (false === $this->druhEmisnejKontrolyEnum->equal($pocetKontrolPodlaDruhuAHodnotenia->druh())) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa druh emisnej kontroly %s, vstupny atribut obsahuje druh emisnej kontroly %s',
                $this->druhEmisnejKontrolyEnum->value,
                $pocetKontrolPodlaDruhuAHodnotenia->druh()->value
            ));
        }

        $this->hodnoteniePocet[$pocetKontrolPodlaDruhuAHodnotenia->hodnotenie()->value] += $pocetKontrolPodlaDruhuAHodnotenia->pocet();
        $this->spolu += $pocetKontrolPodlaDruhuAHodnotenia->pocet();

        return $this;
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum
     */
    public function druh(): DruhEmisnejKontrolyEnum
    {
        return $this->druhEmisnejKontrolyEnum;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum $druhEmisnejKontroly
     * @param array                                                                       $hodnotenia
     *
     * @return void
     */
    public function incrementData(DruhEmisnejKontrolyEnum $druhEmisnejKontroly, array $hodnotenia)
    {
        if (!$this->druhEmisnejKontrolyEnum->equal($druhEmisnejKontroly)) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa druh emisnej kontroly %s, vstupny atribut obsahuje druh emisnej kontroly %s',
                $this->druhEmisnejKontrolyEnum->label(),
                $druhEmisnejKontroly->label()
            ));
        }

        foreach ($this->hodnoteniePocet as $k => $v) {
            if (array_key_exists($k, $hodnotenia)) {
                $this->hodnoteniePocet[$k] += $hodnotenia[$k];
                $this->spolu += $hodnotenia[$k];
            }
        }
    }

    /**
     * @return array
     */
    public function hodnotenia(): array
    {
        return $this->hodnoteniePocet;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'druh' => $this->druhEmisnejKontrolyEnum->value,
            'label' => $this->druhEmisnejKontrolyEnum->label(),
            'data' => [
                'hodnotenia' => $this->hodnoteniePocet,
                'spolu' => $this->spolu,
            ],
        ];
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
